
/*
 *	Declaration of utility functions
 *
 *	Copyright (C) 1999, Rick Gorton
 *
 *	Written by Rick Gorton, 7-Apr-1999
 *	gorton@world.std.com
 *
 * This ATOM tool is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This ATOM tool is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this ATOM tool; see the file COPYING.  If not, write to
 * the Free Software Foundation, 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * NOTE:
 *	If you find this tool useful, the author is interested in knowing
 *	how you used it, and what kind of modifications you found useful.
 *
 *
 */

Inst *PrevIntReg(Inst *this_inst, RegvType this_reg);
Inst *PrevIntRegUse(Inst *this_inst, RegvType this_reg);
Inst *PrevIntRegSet(Inst *this_inst, RegvType this_reg);

Inst *NextIntReg(Inst *this_inst, RegvType this_reg);
Inst *NextIntRegUse(Inst *this_inst, RegvType this_reg);
Inst *NextIntRegSet(Inst *this_inst, RegvType this_reg);

Inst *PrevFloatReg(Inst *this_inst, RegvType this_reg);
Inst *PrevFloatRegUse(Inst *this_inst, RegvType this_reg);
Inst *PrevFloatRegSet(Inst *this_inst, RegvType this_reg);

Inst *NextFloatReg(Inst *this_inst, RegvType this_reg);
Inst *NextFloatRegSet(Inst *this_inst, RegvType this_reg);
Inst *NextFloatRegUse(Inst *this_inst, RegvType this_reg);

BOOLEAN SetsIntReg(Inst *this_inst, RegvType this_reg);
BOOLEAN UsesIntReg(Inst *this_inst, RegvType this_reg);

BOOLEAN SetsFloatReg(Inst *this_inst, RegvType this_reg);
BOOLEAN UsesFloatReg(Inst *this_inst, RegvType this_reg);

enum Opcodes GetOpcode(Inst *this_inst);
int GetLitValue(Inst *this_inst);
